(function(){var _,factory,hasModule,slice=[].slice;hasModule=typeof module!=="undefined"&&module!==null&&module.exports!=null;_={extend:function(){var attr,first,i,len,other,others;first=arguments[0],others=2<=arguments.length?slice.call(arguments,1):[];for(i=0,len=others.length;i<len;i++){other=others[i];for(attr in other){if(typeof other[attr]!=="undefined"){first[attr]=other[attr]}}}return first},isArray:function(input){return Object.prototype.toString.call(input)==="[object Array]"}};factory=function(moment){var Period;if(moment==null){throw new Error("Can't find moment")}Period=function(){Period.prototype.labels={TODAY:"Today",CURRENT_MONTH:"This Month",CURRENT_QUARTER:"This Quarter",CURRENT_FINANCIAL_YEAR:"This Financial Year",LAST_MONTH:"Last Month",LAST_QUARTER:"Last Quarter",LAST_FINANCIAL_YEAR:"Last Financial Year",CUSTOM:"Custom"};function Period(start,end,settings){if(settings==null){settings={}}this.settings={base:12,reference:new Date,startOfFinancialYear:1};if(typeof start==="string"){if(this.labels[start]==null){throw new Error("Invalid period label")}this.set({label:start,settings:end})}else{if(moment.isMoment(start)&&start.isValid()){start=start.toDate()}if(end==null){end=new Date}else if(moment.isMoment(end)&&end.isValid()){end=end.toDate()}else if(!(end instanceof Date)&&end instanceof Object){settings=end;end=new Date}if(start instanceof Date&&end instanceof Date){this.set({dates:[start,end],settings:settings})}else{throw new Error("Wrong parameters")}}this}Period.prototype.set=function(params){if(params==null){throw new Error("No parameters to set")}if(params.settings){this.settings=_.extend(this.settings,params.settings)}if(this.settings.reference!=null&&this.settings.startOfFinancialYear!=null&&this.settings.base!=null){this._loadCache()}else{throw new Error("Missing settings")}if(params.label!=null&&params.dates!=null){throw new Error("Invalid parameters to set. \n Do not provide label and dates.")}else if(params.label!=null){this.label=params.label;this.dates=this._getDatesFromLabel(this.label)}else if(params.dates!=null){this.dates=params.dates;this.label=this._getLabelFromDates(this.dates)}else{this.dates=this._getDatesFromLabel(this.label)}return this};Period.prototype.toString=function(){return this.label};Period.prototype.toDates=function(){return this.dates};Period.prototype.toMoments=function(){return[moment(this.dates[0]),moment(this.dates[1])]};Period.prototype._cache={};Period.prototype._loadCache=function(){var dates,label,results;results=[];for(label in this.labels){dates=this._getDatesFromLabel(label);if(dates[1]!=null){results.push(this._cache[this._buildCacheKey(dates)]=label)}else{results.push(this._cache[this._buildCacheKey(new Date(dates[0]))]=label)}}return results};Period.prototype._getDatesFromLabel=function(label){var date,endDate,lastMonth,startDate;if(!~this.labels.hasOwnProperty(label)){return void 0}if(label==="CUSTOM"){date=new Date;return[date,(new Date).setFullYear(date.getFullYear()+1)]}startDate=new Date(this._timeToZero(this.settings.reference));endDate=new Date(this._timeToZero(this.settings.reference));startDate.setDate(1);switch(label){case"TODAY":startDate=this._timeToZero(new Date);endDate=moment(startDate).endOf("d").toDate();break;case"CURRENT_MONTH":endDate=moment(endDate).endOf("month").toDate();break;case"LAST_MONTH":lastMonth=(endDate.getMonth()-1)%12;startDate.setMonth(lastMonth);endDate.setMonth(lastMonth);endDate=moment(endDate).endOf("month").toDate();break;case"CURRENT_FINANCIAL_YEAR":startDate.setFullYear(this._getCurrentFinancialYear());startDate.setMonth(this.settings.startOfFinancialYear-1);endDate=moment(startDate).add(1,"years").add(-1,"days").endOf("day").toDate();break;case"LAST_FINANCIAL_YEAR":startDate.setFullYear(this._getCurrentFinancialYear()-1);startDate.setMonth(this.settings.startOfFinancialYear-1);endDate=moment(startDate).add(1,"years").add(-1,"days").endOf("day").toDate();break;case"CURRENT_QUARTER":return this._getQuarterDates(this._getCurrentQuarterIndex(),startDate,endDate);case"LAST_QUARTER":return this._getQuarterDates(this._getCurrentQuarterIndex()-1,startDate,endDate)}return[startDate,endDate]};Period.prototype._getLabelFromDates=function(dates){return this._cache[this._buildCacheKey(dates)]||"CUSTOM"};Period.prototype._getLabelFromDate=function(date){return this._cache[this._buildCacheKey(date)]||"CUSTOM"};Period.prototype._getDateFromLabel=function(label){var date,nextMonth;if(!~this.labels.hasOwnProperty(label)){return void 0}if(label==="custom"){return new Date}date=new Date(this._timeToZero(this.settings.reference));if(label.indexOf("firstOf")===0){date.setDate(1)}switch(label){case"firstOfNextMonth":nextMonth=(date.getMonth()+1)%12;date.setMonth(nextMonth);break;case"firstOfFinancialYear":date.setMonth(this.settings.startOfFinancialYear)}return date};Period.prototype._buildCacheKey=function(param){if(_.isArray(param)){return param[0].getTime()+"-"+moment(param[1]).endOf("day").toDate().getTime()}else{return param.getTime()}};Period.prototype._timeToZero=function(date){date.setSeconds(0);date.setMinutes(0);date.setHours(0);return new Date(parseInt(date.getTime()/1e3)*1e3)};Period.prototype._getCurrentFinancialYear=function(){var currentFinancialYear,currentMonth,financialYearMonth;currentFinancialYear=this.settings.reference.getFullYear();currentMonth=this.settings.reference.getMonth();financialYearMonth=this.settings.startOfFinancialYear-1;if(currentMonth<financialYearMonth){currentFinancialYear-=1}return currentFinancialYear};Period.prototype._getQuarterDates=function(index,startDate,endDate){var year;year=this._getCurrentFinancialYear();startDate.setFullYear(year);startDate.setMonth(this.settings.startOfFinancialYear-1);startDate=moment(startDate).add((index-1)*3,"months");endDate=moment(startDate).add(3,"months").add(-1,"days").endOf("day");return[startDate.toDate(),endDate.toDate()]};Period.prototype._currentMonthIndex=function(){var currentMonth,financialYearMonth;currentMonth=this.settings.reference.getMonth();financialYearMonth=this.settings.startOfFinancialYear-1;return(currentMonth-financialYearMonth+this.settings.base)%this.settings.base+1};Period.prototype._getCurrentQuarterIndex=function(){var currentMonthIdx;currentMonthIdx=this._currentMonthIndex();return Math.ceil(currentMonthIdx/(this.settings.base/4))};Period.prototype._getCurrentSemesterIndex=function(){var currentMonthIdx;currentMonthIdx=this._currentMonthIndex();return Math.ceil(currentMonthIdx/(this.settings.base/6))};return Period}();moment.period=function(){return function(func,args,ctor){ctor.prototype=func.prototype;var child=new ctor,result=func.apply(child,args);return Object(result)===result?result:child}(Period,arguments,function(){})};moment.period.isPeriod=function(input){return input instanceof Period};moment.fn.period=function(){return function(func,args,ctor){ctor.prototype=func.prototype;var child=new ctor,result=func.apply(child,args);return Object(result)===result?result:child}(Period,[this].concat(slice.call(arguments)),function(){})};return Period};if(hasModule){return module.exports=factory(require("moment"))}if(typeof define==="function"){define("period",["moment"],function(moment){return factory(moment)})}if(this.moment){this.Period=factory(this.moment)}else if(typeof moment!=="undefined"&&moment!==null){this.Period=factory(moment)}}).call(this);